<?php
/**
 * Custom page walker for this theme.
 *
 * @package Air Ticket Booking
 */

if (!class_exists('Air_Ticket_Booking_Walker_Page')) {
    /**
     * CUSTOM PAGE WALKER
     * A custom walker for pages.
     */
    class Air_Ticket_Booking_Walker_Page extends Walker_Page
    {

        /**
         * Outputs the beginning of the current element in the tree.
         *
         * @param string $air_ticket_booking_output Used to append additional content. Passed by reference.
         * @param WP_Post $page Page data object.
         * @param int $air_ticket_booking_depth Optional. Depth of page. Used for padding. Default 0.
         * @param array $air_ticket_booking_args Optional. Array of arguments. Default empty array.
         * @param int $current_page Optional. Page ID. Default 0.
         * @since 2.1.0
         *
         * @see Walker::start_el()
         */

        public function start_lvl( &$air_ticket_booking_output, $air_ticket_booking_depth = 0, $air_ticket_booking_args = array() ) {
            $air_ticket_booking_indent  = str_repeat( "\t", $air_ticket_booking_depth );
            $air_ticket_booking_output .= "$air_ticket_booking_indent<ul class='sub-menu'>\n";
        }

        public function start_el(&$air_ticket_booking_output, $page, $air_ticket_booking_depth = 0, $air_ticket_booking_args = array(), $current_page = 0)
        {

            if (isset($air_ticket_booking_args['item_spacing']) && 'preserve' === $air_ticket_booking_args['item_spacing']) {
                $t = "\t";
                $n = "\n";
            } else {
                $t = '';
                $n = '';
            }
            if ($air_ticket_booking_depth) {
                $air_ticket_booking_indent = str_repeat($t, $air_ticket_booking_depth);
            } else {
                $air_ticket_booking_indent = '';
            }

            $air_ticket_booking_css_class = array('page_item', 'page-item-' . $page->ID);

            if (isset($air_ticket_booking_args['pages_with_children'][$page->ID])) {
                $air_ticket_booking_css_class[] = 'page_item_has_children';
            }

            if (!empty($current_page)) {
                $_current_page = get_post($current_page);
                if ($_current_page && in_array($page->ID, $_current_page->ancestors, true)) {
                    $air_ticket_booking_css_class[] = 'current_page_ancestor';
                }
                if ($page->ID === $current_page) {
                    $air_ticket_booking_css_class[] = 'current_page_item';
                } elseif ($_current_page && $page->ID === $_current_page->post_parent) {
                    $air_ticket_booking_css_class[] = 'current_page_parent';
                }
            } elseif (get_option('page_for_posts') === $page->ID) {
                $air_ticket_booking_css_class[] = 'current_page_parent';
            }

            /** This filter is documented in wp-includes/class-walker-page.php */
            $air_ticket_booking_css_classes = implode(' ', apply_filters('page_css_class', $air_ticket_booking_css_class, $page, $air_ticket_booking_depth, $air_ticket_booking_args, $current_page));
            $air_ticket_booking_css_classes = $air_ticket_booking_css_classes ? ' class="' . esc_attr($air_ticket_booking_css_classes) . '"' : '';

            if ('' === $page->post_title) {
                /* translators: %d: ID of a post. */
                $page->post_title = sprintf(__('#%d (no title)', 'air-ticket-booking'), $page->ID);
            }

            $air_ticket_booking_args['link_before'] = empty($air_ticket_booking_args['link_before']) ? '' : $air_ticket_booking_args['link_before'];
            $air_ticket_booking_args['link_after'] = empty($air_ticket_booking_args['link_after']) ? '' : $air_ticket_booking_args['link_after'];

            $air_ticket_booking_atts = array();
            $air_ticket_booking_atts['href'] = get_permalink($page->ID);
            $air_ticket_booking_atts['aria-current'] = ($page->ID === $current_page) ? 'page' : '';

            /** This filter is documented in wp-includes/class-walker-page.php */
            $air_ticket_booking_atts = apply_filters('page_menu_link_attributes', $air_ticket_booking_atts, $page, $air_ticket_booking_depth, $air_ticket_booking_args, $current_page);

            $air_ticket_booking_attributes = '';
            foreach ($air_ticket_booking_atts as $attr => $air_ticket_booking_value) {
                if (!empty($air_ticket_booking_value)) {
                    $air_ticket_booking_value = ('href' === $attr) ? esc_url($air_ticket_booking_value) : esc_attr($air_ticket_booking_value);
                    $air_ticket_booking_attributes .= ' ' . $attr . '="' . $air_ticket_booking_value . '"';
                }
            }

            $air_ticket_booking_args['list_item_before'] = '';
            $air_ticket_booking_args['list_item_after'] = '';
            $air_ticket_booking_args['icon_rennder'] = '';
            // Wrap the link in a div and append a sub menu toggle.
            if (isset($air_ticket_booking_args['show_toggles']) && true === $air_ticket_booking_args['show_toggles']) {
                // Wrap the menu item link contents in a div, used for positioning.
                $air_ticket_booking_args['list_item_after'] = '';
            }


            // Add icons to menu items with children.
            if (isset($air_ticket_booking_args['show_sub_menu_icons']) && true === $air_ticket_booking_args['show_sub_menu_icons']) {
                if (isset($air_ticket_booking_args['pages_with_children'][$page->ID])) {
                    $air_ticket_booking_args['icon_rennder'] = '';
                }
            }

            // Add icons to menu items with children.
            if (isset($air_ticket_booking_args['show_toggles']) && true === $air_ticket_booking_args['show_toggles']) {
                if (isset($air_ticket_booking_args['pages_with_children'][$page->ID])) {

                    $toggle_target_string = '.page_item.page-item-' . $page->ID . ' > .sub-menu';

                    $air_ticket_booking_args['list_item_after'] = '<button type="button" class="theme-aria-button submenu-toggle" data-toggle-target="' . $toggle_target_string . '" data-toggle-type="slidetoggle" data-toggle-duration="250"><span class="btn__content" tabindex="-1"><span class="screen-reader-text">' . __( 'Show sub menu', 'air-ticket-booking' ) . '</span>' . air_ticket_booking_get_theme_svg( 'chevron-down' ) . '</span></button>';
                }
            }

            if (isset($air_ticket_booking_args['show_toggles']) && true === $air_ticket_booking_args['show_toggles']) {

                $air_ticket_booking_output .= $air_ticket_booking_indent . sprintf(
                        '<li%s>%s%s<a%s>%s%s%s</a>%s%s',
                        $air_ticket_booking_css_classes,
                        '<div class="submenu-wrapper">',
                        $air_ticket_booking_args['list_item_before'],
                        $air_ticket_booking_attributes,
                        $air_ticket_booking_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $air_ticket_booking_args['link_after'],
                        $air_ticket_booking_args['list_item_after'],
                        '</div>'
                    );

            }else{

                $air_ticket_booking_output .= $air_ticket_booking_indent . sprintf(
                        '<li%s>%s<a%s>%s%s%s%s</a>%s',
                        $air_ticket_booking_css_classes,
                        $air_ticket_booking_args['list_item_before'],
                        $air_ticket_booking_attributes,
                        $air_ticket_booking_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $air_ticket_booking_args['icon_rennder'],
                        $air_ticket_booking_args['link_after'],
                        $air_ticket_booking_args['list_item_after']
                    );

            }

            if (!empty($air_ticket_booking_args['show_date'])) {
                if ('modified' === $air_ticket_booking_args['show_date']) {
                    $air_ticket_booking_time = $page->post_modified;
                } else {
                    $air_ticket_booking_time = $page->post_date;
                }

                $air_ticket_booking_date_format = empty($air_ticket_booking_args['date_format']) ? '' : $air_ticket_booking_args['date_format'];
                $air_ticket_booking_output .= ' ' . mysql2date($air_ticket_booking_date_format, $air_ticket_booking_time);
            }
        }
    }
}